//+------------------------------------------------------------------+
//|                                              bb-Percent B HL.mq4 |
//|                                          Copyright 2015 Andrea B |
//|                                             https://www.mql5.com |
//+------------------------------------------------------------------+

#property copyright "Copyright 2015"
#property link      ""
#property version   "1.00"

#property indicator_separate_window
#property indicator_buffers 1
#property indicator_color1 Red
#property indicator_width1 3
#property indicator_level1 0
#property indicator_level2 -30
#property indicator_level3 100
#property indicator_level4 40


extern ENUM_TIMEFRAMES    TimeFrame = PERIOD_CURRENT;
extern int bbPeriod   = 20;
extern int bbDeviation  = 2;
extern int bbPrice = 0;

double PercentVariation[];
string indicatorFileName;
bool   returnBars;


//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit()
  {
//--- indicator buffers mapping
IndicatorBuffers(1);

SetIndexBuffer(0,PercentVariation);
SetIndexStyle (0,DRAW_LINE);

indicatorFileName = WindowExpertName();
returnBars        = TimeFrame==-99;
TimeFrame         = MathMax(TimeFrame,_Period);
IndicatorShortName(timeFrameToString(TimeFrame)+" %b HL");
   return(INIT_SUCCEEDED);
  }

int start()
{  RefreshRates();
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1); 
         if (returnBars) { PercentVariation[0] = limit+1; return(0); }
         if (TimeFrame != Period())
         {
            limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,TimeFrame,indicatorFileName,-99,0,0)*TimeFrame/Period()));
            for (int i=limit; i>=0; i--)
            {
               int x = iBarShift(NULL,TimeFrame,Time[i]);               
                  PercentVariation[i]  = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,bbPeriod,bbDeviation,bbPrice,0,x);     
            }
         return(0);                
         }
//average stddev 
//differrence std dev- average
for (i =0; i < limit; i++)
   {
     
      
      double bbUpper=iBands(NULL,0,bbPeriod,bbDeviation,0,bbPrice,MODE_UPPER,i);
      double bbLower=iBands(NULL,0,bbPeriod,bbDeviation,0,bbPrice,MODE_LOWER,i);
      double bbMedian=iBands(NULL,0,bbPeriod,bbDeviation,0,bbPrice,MODE_MAIN,i);
      
      if ((bbUpper-bbLower)!=0)
            PercentVariation[i]=((Close[i]-bbLower)/(bbUpper-bbLower))*100.0;
      else  PercentVariation[i]=0;
      if  ((bbUpper-bbLower)!=0 && PercentVariation[i]>65) 
           {  if (Close[i]>Open[i]) PercentVariation[i]=((High[i]-bbLower)/(bbUpper-bbLower))*100.0;
              if (Close[i]<Open[i]) PercentVariation[i]=((Close[i]-bbLower)/(bbUpper-bbLower))*100.0;
                 
           }
     
      if  ((bbUpper-bbLower)!=0 && PercentVariation[i]<35) 
           {  if (Close[i]>Open[i]) PercentVariation[i]=((Close[i]-bbLower)/(bbUpper-bbLower))*100.0;
              if (Close[i]<Open[i])  
                 { if( Low[i]>bbLower ) PercentVariation[i]=((Low[i]-bbLower)/(bbUpper-bbLower))*100.0;
                   if( Low[i]==bbLower) PercentVariation[i]=0;
                   if( Low[i]<bbLower ) PercentVariation[i]=-((bbLower-Low[i])/(bbUpper-bbLower))*100.0;
                  }
            }  
    
   }
   return(0);
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}